import { Client } from "oceanic.js";
import "dotenv/config";
import commands from "./commands";

const token = process.env.DISCORD_TOKEN;
if (!token) {
  console.error("No `DISCORD_TOKEN` was specified!!");
  process.exit(1);
}

const client = new Client({
  auth: `Bot ${token}`,
  gateway: {
    intents: ["ALL"],
  },
});

// --

client.on("ready", async () => {
  console.log("Ready as", client.user.tag);
});

const PREFIX = "!!";

client.on("messageCreate", async (msg) => {
  if (msg.author.bot) return;

  let first = msg.content.split(/\s/).shift();
  if (first?.startsWith(PREFIX) === false) return;
  let cmdName = first!.slice(PREFIX.length);

  let command = commands.find((c) => c.name === cmdName);

  if (command === undefined) return;

  if ((await command.checkPerm(msg)) === false) {
    await msg.createReaction("❌");
    return;
  }

  await command?.handler(msg);
});

client.on("error", (err) => {
  console.error("Error!!", err);
});

client.connect();
